package sk.seges.acris.shared.model.dto;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.annotation.Generated;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import sk.seges.acris.core.client.rpc.IDataTransferObject;
import sk.seges.acris.node.MenuItem;
import sk.seges.sesam.pap.model.annotation.TransferObjectMapping;

@SuppressWarnings("serial")
@TransferObjectMapping(dtoClass = ContentDTO.class,
		domainClassName = "sk.seges.acris.domain.server.domain.base.ContentBase", 
		configurationClassName = "sk.seges.acris.server.model.dto.configuration.ContentDTOConfiguration", 
		generateConverter = false, generateDto = false)
@Generated(value = "sk.seges.corpis.pap.model.hibernate.HibernateTransferObjectProcessor")
public class ContentDTO implements IDataTransferObject, Serializable {

	private String contentDetached;

	private Date created;

	private String decoration;

	private String defaultStyleClass;

	private Boolean defaultlyLoaded;

	private String description;

	private String group;

	private Boolean hasChildren;

	private ContentPkDTO id;

	private Integer index;

	private String keywords;

	private String label;

	private MenuItem menuItemsData;

	private Date modified;

	private String niceUrl;

	private String pageName;

	private String params;

	private ContentDTO parent;

	private String position;

	private String ref;

	private String stylePrefix;

	private List<ContentDTO> subContents;

	private String title;

	private String token;

	private Integer version;

	public ContentDTO() {
	}
	public ContentDTO(String contentDetached, Date created, String decoration, String defaultStyleClass, Boolean defaultlyLoaded, String description, String group, Boolean hasChildren, ContentPkDTO id, Integer index, String keywords, String label, MenuItem menuItemsData, Date modified, String niceUrl, String pageName, String params, ContentDTO parent, String position, String ref, String stylePrefix, List<ContentDTO> subContents, String title, String token, Integer version) {
		this.contentDetached = contentDetached;
		this.created = created;
		this.decoration = decoration;
		this.defaultStyleClass = defaultStyleClass;
		this.defaultlyLoaded = defaultlyLoaded;
		this.description = description;
		this.group = group;
		this.hasChildren = hasChildren;
		this.id = id;
		this.index = index;
		this.keywords = keywords;
		this.label = label;
		this.menuItemsData = menuItemsData;
		this.modified = modified;
		this.niceUrl = niceUrl;
		this.pageName = pageName;
		this.params = params;
		this.parent = parent;
		this.position = position;
		this.ref = ref;
		this.stylePrefix = stylePrefix;
		this.subContents = subContents;
		this.title = title;
		this.token = token;
		this.version = version;
	}

	public String getContentDetached() {
		return contentDetached;
	}

	public void setContentDetached(String contentDetached) {
		this.contentDetached = contentDetached;
	}

	public Date getCreated() {
		return created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	public String getDecoration() {
		return decoration;
	}

	public void setDecoration(String decoration) {
		this.decoration = decoration;
	}

	public String getDefaultStyleClass() {
		return defaultStyleClass;
	}

	public void setDefaultStyleClass(String defaultStyleClass) {
		this.defaultStyleClass = defaultStyleClass;
	}

	public Boolean getDefaultlyLoaded() {
		return defaultlyLoaded;
	}

	public void setDefaultlyLoaded(Boolean defaultlyLoaded) {
		this.defaultlyLoaded = defaultlyLoaded;
	}

	@Size(min = 0, max = 255)
	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getGroup() {
		return group;
	}

	public void setGroup(String group) {
		this.group = group;
	}

	public Boolean getHasChildren() {
		return hasChildren;
	}

	public void setHasChildren(Boolean hasChildren) {
		this.hasChildren = hasChildren;
	}

	public ContentPkDTO getId() {
		return id;
	}

	public void setId(ContentPkDTO id) {
		this.id = id;
	}

	public Integer getIndex() {
		return index;
	}

	public void setIndex(Integer index) {
		this.index = index;
	}

	@Size(min = 0, max = 255)
	public String getKeywords() {
		return keywords;
	}

	public void setKeywords(String keywords) {
		this.keywords = keywords;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public MenuItem getMenuItemsData() {
		return menuItemsData;
	}

	public void setMenuItemsData(MenuItem menuItemsData) {
		this.menuItemsData = menuItemsData;
	}

	public Date getModified() {
		return modified;
	}

	public void setModified(Date modified) {
		this.modified = modified;
	}

	@Size(min = 1, max = 255)
	@Pattern(regexp = "[a-zA-Z0-9\\-_/]*")
	public String getNiceUrl() {
		return niceUrl;
	}

	public void setNiceUrl(String niceUrl) {
		this.niceUrl = niceUrl;
	}

	public String getPageName() {
		return pageName;
	}

	public void setPageName(String pageName) {
		this.pageName = pageName;
	}

	public String getParams() {
		return params;
	}

	public void setParams(String params) {
		this.params = params;
	}

	public ContentDTO getParent() {
		return parent;
	}

	public void setParent(ContentDTO parent) {
		this.parent = parent;
	}

	public String getPosition() {
		return position;
	}

	public void setPosition(String position) {
		this.position = position;
	}

	public String getRef() {
		return ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	public String getStylePrefix() {
		return stylePrefix;
	}

	public void setStylePrefix(String stylePrefix) {
		this.stylePrefix = stylePrefix;
	}

	public List<ContentDTO> getSubContents() {
		return subContents;
	}

	public void setSubContents(List<ContentDTO> subContents) {
		this.subContents = subContents;
	}

	@Size(min = 0, max = 255)
	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getToken() {
		return token;
	}

	public void setToken(String token) {
		this.token = token;
	}

	public Integer getVersion() {
		return version;
	}

	public void setVersion(Integer version) {
		this.version = version;
	}

	private boolean processingEquals = false;
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ContentDTO other = (ContentDTO) obj;
		if (contentDetached == null) {
			if (other.contentDetached != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!contentDetached.equals(other.contentDetached)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (created == null) {
			if (other.created != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!created.equals(other.created)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (decoration == null) {
			if (other.decoration != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!decoration.equals(other.decoration)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (defaultStyleClass == null) {
			if (other.defaultStyleClass != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!defaultStyleClass.equals(other.defaultStyleClass)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (defaultlyLoaded == null) {
			if (other.defaultlyLoaded != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!defaultlyLoaded.equals(other.defaultlyLoaded)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (description == null) {
			if (other.description != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!description.equals(other.description)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (group == null) {
			if (other.group != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!group.equals(other.group)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (hasChildren == null) {
			if (other.hasChildren != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!hasChildren.equals(other.hasChildren)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (id == null) {
			if (other.id != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!id.equals(other.id)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (index == null) {
			if (other.index != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!index.equals(other.index)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (keywords == null) {
			if (other.keywords != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!keywords.equals(other.keywords)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (label == null) {
			if (other.label != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!label.equals(other.label)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (menuItemsData == null) {
			if (other.menuItemsData != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!menuItemsData.equals(other.menuItemsData)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (modified == null) {
			if (other.modified != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!modified.equals(other.modified)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (niceUrl == null) {
			if (other.niceUrl != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!niceUrl.equals(other.niceUrl)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (pageName == null) {
			if (other.pageName != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!pageName.equals(other.pageName)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (params == null) {
			if (other.params != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!params.equals(other.params)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (parent == null) {
			if (other.parent != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!parent.equals(other.parent)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (position == null) {
			if (other.position != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!position.equals(other.position)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (ref == null) {
			if (other.ref != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!ref.equals(other.ref)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (stylePrefix == null) {
			if (other.stylePrefix != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!stylePrefix.equals(other.stylePrefix)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (subContents == null) {
			if (other.subContents != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!subContents.equals(other.subContents)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (title == null) {
			if (other.title != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!title.equals(other.title)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (token == null) {
			if (other.token != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!token.equals(other.token)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		if (version == null) {
			if (other.version != null)
				return false;
		} else { 
			if (!processingEquals) {
				processingEquals = true;
				if (!version.equals(other.version)) {
					processingEquals = false;
					return false;
				} else {
					processingEquals = false;
				}
			}
		}
		return true;
	}

	private boolean processingHashCode = false;
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((contentDetached == null) ? 0 : contentDetached.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((created == null) ? 0 : created.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((decoration == null) ? 0 : decoration.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((defaultStyleClass == null) ? 0 : defaultStyleClass.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((defaultlyLoaded == null) ? 0 : defaultlyLoaded.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((description == null) ? 0 : description.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((group == null) ? 0 : group.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((hasChildren == null) ? 0 : hasChildren.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((id == null) ? 0 : id.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((index == null) ? 0 : index.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((keywords == null) ? 0 : keywords.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((label == null) ? 0 : label.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((menuItemsData == null) ? 0 : menuItemsData.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((modified == null) ? 0 : modified.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((niceUrl == null) ? 0 : niceUrl.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((pageName == null) ? 0 : pageName.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((params == null) ? 0 : params.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((parent == null) ? 0 : parent.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((position == null) ? 0 : position.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((ref == null) ? 0 : ref.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((stylePrefix == null) ? 0 : stylePrefix.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((subContents == null) ? 0 : subContents.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((title == null) ? 0 : title.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((token == null) ? 0 : token.hashCode());
			processingHashCode = false;
		}
		if (!processingHashCode) {
			processingHashCode = true;
			result = prime * result + ((version == null) ? 0 : version.hashCode());
			processingHashCode = false;
		}
		return result;
	}
}